package cerebral.colors;

import java.awt.Graphics;

import prefuse.util.ColorLib;

public class ConstantRange extends ColorRangeComponent {

    private static final long serialVersionUID = 1L;

    int color;

    public ConstantRange(double min, ColorRange lowerRange, int color) {
        super(min, lowerRange);
        this.color = color;
    }

    public int getColor(double val) {
        if (isInRange(val))
            return color;
        else if (val < min) {
            // We're off the lefte side of the scale. Clip to min
            return color;
        } else if (higherRange instanceof TerminateRange) {
            // off the right side
            return color;
        } else {
            return higherRange.getColor(val);
        }
    }

    public void paint(Graphics g) {
        g.setColor(ColorLib.getColor(color));
        g.fillRect(0, 0, getWidth(), getHeight());
        super.paint(g);
    }

}
