package cerebral.parallelCoordinates.cluster;

import java.util.Iterator;
import java.util.List;

import prefuse.Visualization;
import prefuse.action.assignment.ColorAction;
import prefuse.data.tuple.TupleSet;
import prefuse.util.ColorLib;
import prefuse.visual.VisualItem;
import cerebral.colors.ColorManager;
import cerebral.parallelCoordinates.ParallelCoordinates;

public class ClusterGlyphColor extends ColorAction {

	private KMeansCluster kMeans;

	private Visualization dataVis;

	public ClusterGlyphColor(String group, KMeansCluster kMeans,
			Visualization dataVis) {
		super(group, VisualItem.FILLCOLOR);
		this.kMeans = kMeans;
		this.dataVis = dataVis;

	}

	public int getColor(VisualItem cluster) {
		TupleSet selected = dataVis.getFocusGroup(ParallelCoordinates.SELECTED);

		boolean allSelected = true;
		List clusterMembers = kMeans.getMembers(cluster.getRow());
		Iterator it = clusterMembers.iterator();
		while (it.hasNext()) {
			VisualItem clusterMember = (VisualItem) it.next();
			if (!selected.containsTuple(clusterMember)) {
				allSelected = false;
				break;
			}
		}

		cluster.setHighlighted(allSelected);

		if (allSelected) {
			return ColorLib.gray(0);
		} else {
            return ColorManager.increasedContrast(ColorLib.color(m_vis.getDisplay(0)
                    .getBackground()));
		}
	}

}
