package cerebral.parallelCoordinates.controls;

import java.awt.event.MouseEvent;

import cerebral.parallelCoordinates.YDisplay;

import prefuse.controls.ControlAdapter;
import prefuse.util.ui.UILib;
import prefuse.visual.VisualItem;

public class ScaleControl extends ControlAdapter {

	private double totalScale  = 100.0;
	private int yLast;
	private YDisplay yDisplay;

	public ScaleControl(YDisplay yDisplay) {
		this.yDisplay = yDisplay;
       
	}

	public void mousePressed(MouseEvent e) {
		if (UILib.isButtonPressed(e, RIGHT_MOUSE_BUTTON)) {
			yLast = e.getY();
		}
	}

	public void mouseDragged(MouseEvent e) {
		if (UILib.isButtonPressed(e, RIGHT_MOUSE_BUTTON)) {
			 int y = e.getY();
			 double dy = y- yLast ;

			 double zoom = 1 + (dy) / 5000;
			 if (totalScale * zoom < 10000.0 && totalScale * zoom > 1.0){
			    
                yDisplay.scale(zoom);
				totalScale *= zoom;
			}
		}
	}

	public void itemPressed(VisualItem item, MouseEvent e) {
		mousePressed(e);
	}

	public void itemDragged(VisualItem item, MouseEvent e) {
		mouseDragged(e);
	}

}
