package cerebral.parallelCoordinates.render;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.geom.Line2D;
import java.awt.geom.Point2D;

import cerebral.colors.ColorManager;

import prefuse.render.Renderer;
import prefuse.util.ColorLib;
import prefuse.visual.VisualItem;

public class CoordinateRenderer implements Renderer {

	private Line2D line = new Line2D.Double();

	public CoordinateRenderer() {
	}

	public boolean locatePoint(Point2D p, VisualItem item) {
		return item.getBounds().contains(p);
	}

	public void render(Graphics2D g, VisualItem item) {
		BasicStroke stroke = item.getStroke();
		g.setStroke(stroke);
		Color color = ColorLib.getColor(item.getFillColor());
		//Egregious hack.  Want to be able to highlight the currently selected
		//axes in blue.  Otherwise, just want them to be darkened background colors
		if (color.getBlue() == 0){
			color = ColorLib.getColor(ColorManager.increasedContrast(ColorLib
					.color(item.getVisualization().getDisplay(0)
							.getBackground()), 0.3f));
		}
		g.setColor(color);
		
		double x = item.getX();
		double h = item.getSize();
		line.setLine(x, item.getY(), x, h + item.getY());
		g.draw(line);

	}

	public void setBounds(VisualItem item) {

		double x = item.getX();
		double h = item.getSize();
		BasicStroke stroke = item.getStroke();
		float width = stroke.getLineWidth();

		item.setBounds(x - width * 2, item.getY(), width * 4, h);

	}

}
